#! /bin/bash
source $FW4EX_LIB_DIR/basicLib.sh
source $FW4EX_LIB_DIR/moreLib.sh

CFLAGS='-std=c99 -pedantic -Wall -Werror'
CC=gcc
OFILE=min.o

# HACK, plutot que compile.sh sorte avec le code 51 et que l'on
# n'enchaine pas sur check.sh, on tourne toujours check.sh mais
# l'on regarde si min.o existe bien!                                FIXME
if [[ ! -r $OFILE ]]
then exit 
fi

MIN=$RANDOM
MAX=$RANDOM
if [ $MIN -gt $MAX ]
then
    tmp=$MAX
    MAX=$MIN
    MIN=$tmp
fi
fw4ex_generate_xml_comment "MIN=$MIN, MAX=$MAX"

main=$FW4EX_EXERCISE_DIR/tests/main9.c
DATA_NUMBER=5
cat <<EOF
<p> Voici le contenu du fichier mettant en oeuvre votre fonction:
<pre>
EOF
fw4ex_transcode_carefully < $FW4EX_EXERCISE_DIR/tests/main9.c
cat <<EOF
</pre></p>
EOF

compileThenRun () {
    local MIN=$1
    local A=$2
    local B=$3
    local MAINFLAGS="-DMIN=$MIN -DA=$A -DB=$B"
    echo "<section>"
    # compilation
    cat <<EOF
<p> Je compile ce fichier avec la commande 
<code>$CC $CFLAGS $MAINFLAGS -o $TMPDIR/main $main $OFILE</code>
</p>
EOF
    if fw4ex_confine $CC $CFLAGS $MAINFLAGS -o $TMPDIR/main $main $OFILE 2>$TMPDIR/err.s 
    then
        abort=false
        cat <<EOF
<p>La compilation a réussi.</p>
EOF
        # execution
        cat <<EOF
<p> Je demande à exécuter le programme obtenu. </p>
EOF
        fw4ex_confine $TMPDIR/main 1>$TMPDIR/out.s 2>$TMPDIR/err.s
        CODE=$?
        if [[ "$CODE" = 0 ]]
        then
            cat <<EOF
<p> Impeccable! Vous gagnez 
EOF
            fw4ex_win 1/$DATA_NUMBER
            echo " points</p>"
        else
            cat <<EOF
<p> La réponse n'est pas celle que j'attendais! </p>
EOF
        fi
        fw4ex_generate_xml_comment "code:$CODE"

        # affichage stdout
        if [[ -s $TMPDIR/out.s ]]
        then
            echo "<warning>Votre programme a cependant aussi produit ceci:<pre>"
            fw4ex_transcode_carefully < $TMPDIR/out.s
            echo "</pre></warning>"
        fi
        
        # affichage anomalie
        if [[ -s $TMPDIR/err.s ]]
        then
            cat <<EOF
<error>Attention: l'exécution a produit, sur son flux d'erreur, les 
anomalies suivantes: <pre>
EOF
            fw4ex_transcode_carefully < $TMPDIR/err.s
            cat <<EOF
</pre></error>
EOF
        fi
        
    else
        abort=true
        cat <<EOF
<error>La compilation s'est mal passée!
EOF

        # affichage anomalies
        if [[ -s $TMPDIR/err.s ]]
        then
            cat <<EOF
Attention: la compilation a produit, sur son flux d'erreur, les 
anomalies suivantes: <pre>
EOF
            fw4ex_transcode_carefully < $TMPDIR/err.s
            cat <<EOF
</pre>
EOF
        fi
        cat <<EOF
</error>
EOF

        # fin prematuree si probleme
        if $abort
        then 
            cat <<EOF
<p> La compilation ayant échouée, j'abandonne donc ce test. </p>
EOF
            exit
        fi
    fi
    echo "</section>"
}

# test1     3 5
compileThenRun $MIN $MIN $MAX
# test2     5 5
compileThenRun $MAX $MAX $MAX
# test2     5 3
compileThenRun $MIN $MAX $MIN
# test2     -5 -3
compileThenRun -$MAX -$MIN -$MAX
# test2     -3 -5
compileThenRun -$MAX -$MAX -$MIN

cat <<EOF
<p>
Fin de correction automatique.
</p>
EOF

# Local Variables: ##
# coding:utf-8 ##
# End: ##
# end of check.sh
